#pragma once

#include <QUndoStack>

class Scene;
class Node;

//----------------------------------------------------------------------
//	m[h폜
class UndoRemoveNodeCommand : public QUndoCommand
{
public:
	UndoRemoveNodeCommand(Scene *scene, Node *node);
	~UndoRemoveNodeCommand() {};
	
public:
	void	undo();
	void	redo();

private:
	Scene	*m_scene;
	Node	*m_node;			//	폜ꂽm[h
	Node	*m_parentNode;		//	폜ꂽm[h̐em[h
	int		m_index;			//	Ԗڂ̌Z킩 (0..*)
};
//----------------------------------------------------------------------
//	m[hǉ
class UndoAddNodeCommand : public QUndoCommand
{
public:
#if 1
	UndoAddNodeCommand(Scene *scene, Node *node);
#else
	UndoAddNodeCommand(Scene *scene, Node *node, Node *parentNode, int index);
#endif
	~UndoAddNodeCommand() {};
	
public:
	void	undo();
	void	redo();

private:
	Scene	*m_scene;
	Node	*m_node;			//	ǉꂽm[h
	Node	*m_parentNode;		//	ǉꂽm[h̐em[h
	int		m_index;			//	Ԗڂ̌Z킩 (0..*)
};
//----------------------------------------------------------------------
//	m[hړ
class UndoMoveNodeCommand : public QUndoCommand
{
public:
	UndoMoveNodeCommand(Scene *scene, Node *node,
						Node *sp, int si,
						Node *dp);
	~UndoMoveNodeCommand() {};
	
public:
	void	undo();
	void	redo();

private:
	Scene	*m_scene;
	Node	*m_node;			//	ړm[h
	Node	*m_srcPN;			//	ړem[h
	int		m_srcIx;			//	ړqԍi0..*j
	Node	*m_dstPN;			//	ړem[h
	int		m_dstIx;			//	ړqԍi0..*j
};
//----------------------------------------------------------------------
//	m[heLXgC
class UndoEditNodeTextCommand : public QUndoCommand
{
public:
	UndoEditNodeTextCommand(Scene *scene, Node *node,
						const QString &text)
		: m_scene(scene)
		, m_node(node)
		, m_text(text)
		{}
	~UndoEditNodeTextCommand() {};
	
public:
	void	undo() { doUndoRedo(); }
	void	redo() { doUndoRedo(); }

protected:
	void	doUndoRedo();

private:
	Scene	*m_scene;
	Node	*m_node;			//	ړm[h
	QString	m_text;
};
